## mkvtoolnix-58.0.0.tar.xz

=== lib/fmt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1...3.18)

# Fallback for using newer policies on CMake <3.12.
if(${CMAKE_VERSION} VERSION_LESS 3.12)
  cmake_policy(VERSION ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION})
endif()

# Determine if fmt is built as a subproject (using add_subdirectory)
# or if it is the master project.
set(MASTER_PROJECT OFF)
if (CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(MASTER_PROJECT ON)
  message(STATUS "CMake version: ${CMAKE_VERSION}")
endif ()

# Joins arguments and places the results in ${result_var}.
function(join result_var)
  set(result )
  foreach (arg ${ARGN})
    set(result "${result}${arg}")
  endforeach ()
  set(${result_var} "${result}" PARENT_SCOPE)
endfunction()

include(CMakeParseArguments)

# Sets a cache variable with a docstring joined from multiple arguments:
#   set(<variable> <value>... CACHE <type> <docstring>...)
# This allows splitting a long docstring for readability.
function(set_verbose)
  # cmake_parse_arguments is broken in CMake 3.4 (cannot parse CACHE) so use
  # list instead.
  list(GET ARGN 0 var)
  list(REMOVE_AT ARGN 0)
  list(GET ARGN 0 val)
  list(REMOVE_AT ARGN 0)
  list(REMOVE_AT ARGN 0)
  list(GET ARGN 0 type)
  list(REMOVE_AT ARGN 0)
  join(doc ${ARGN})
  set(${var} ${val} CACHE ${type} ${doc})
endfunction()

# Set the default CMAKE_BUILD_TYPE to Release.
# This should be done before the project command since the latter can set
# CMAKE_BUILD_TYPE itself (it does so for nmake).
if (MASTER_PROJECT AND NOT CMAKE_BUILD_TYPE)
  set_verbose(CMAKE_BUILD_TYPE Release CACHE STRING
              "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or "
              "CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
endif ()

project(FMT CXX)
include(GNUInstallDirs)
set_verbose(FMT_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR} CACHE STRING
            "Installation directory for include files, a relative path that "
            "will be joined with ${CMAKE_INSTALL_PREFIX} or an absolute path.")

option(FMT_PEDANTIC "Enable extra warnings and expensive tests." OFF)
option(FMT_WERROR "Halt the compilation with an error on compiler warnings."
       OFF)

# Options that control generation of various targets.
option(FMT_DOC "Generate the doc target." ${MASTER_PROJECT})
option(FMT_INSTALL "Generate the install target." ${MASTER_PROJECT})
option(FMT_TEST "Generate the test target." ${MASTER_PROJECT})
option(FMT_FUZZ "Generate the fuzz target." OFF)
option(FMT_CUDA_TEST "Generate the cuda-test target." OFF)
option(FMT_OS "Include core requiring OS (Windows/Posix) " ON)

# Get version from core.h
file(READ include/fmt/core.h core_h)
if (NOT core_h MATCHES "FMT_VERSION ([0-9]+)([0-9][0-9])([0-9][0-9])")
  message(FATAL_ERROR "Cannot get FMT_VERSION from core.h.")
endif ()
# Use math to skip leading zeros if any.
math(EXPR CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_MATCH_1})
math(EXPR CPACK_PACKAGE_VERSION_MINOR ${CMAKE_MATCH_2})
math(EXPR CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_3})
join(FMT_VERSION ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.
                 ${CPACK_PACKAGE_VERSION_PATCH})
message(STATUS "Version: ${FMT_VERSION}")

message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

if (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
endif ()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/support/cmake")

include(cxx14)
include(CheckCXXCompilerFlag)
include(JoinPaths)

list(FIND CMAKE_CXX_COMPILE_FEATURES "cxx_variadic_templates" index)
if (${index} GREATER -1)
  # Use cxx_variadic_templates instead of more appropriate cxx_std_11 for
  # compatibility with older CMake versions.
  set(FMT_REQUIRED_FEATURES cxx_variadic_templates)
endif ()
message(STATUS "Required features: ${FMT_REQUIRED_FEATURES}")

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU")
  set(PEDANTIC_COMPILE_FLAGS -pedantic-errors -Wall -Wextra -pedantic
      -Wold-style-cast -Wundef
      -Wredundant-decls -Wwrite-strings -Wpointer-arith
      -Wcast-qual -Wformat=2 -Wmissing-include-dirs
      -Wcast-align
      -Wctor-dtor-privacy -Wdisabled-optimization
      -Winvalid-pch -Woverloaded-virtual
      -Wconversion -Wswitch-enum -Wundef
      -Wno-ctor-dtor-privacy -Wno-format-nonliteral)
  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 4.6)
      set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS} -Wnoexcept
         -Wno-dangling-else -Wno-unused-local-typedefs)
  endif ()
  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
      set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS} -Wdouble-promotion
          -Wtrampolines -Wzero-as-null-pointer-constant -Wuseless-cast
          -Wvector-operation-performance -Wsized-deallocation -Wshadow)
  endif ()
  if (NOT CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0)
      set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS} -Wshift-overflow=2
          -Wnull-dereference -Wduplicated-cond)
  endif ()
  set(WERROR_FLAG -Werror)
endif ()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(PEDANTIC_COMPILE_FLAGS -Wall -Wextra -pedantic -Wconversion -Wundef
      -Wdeprecated -Wweak-vtables -Wshadow)
  check_cxx_compiler_flag(-Wzero-as-null-pointer-constant HAS_NULLPTR_WARNING)
  if (HAS_NULLPTR_WARNING)
    set(PEDANTIC_COMPILE_FLAGS ${PEDANTIC_COMPILE_FLAGS}
        -Wzero-as-null-pointer-constant)
  endif ()
  set(WERROR_FLAG -Werror)
endif ()

if (MSVC)
  set(PEDANTIC_COMPILE_FLAGS /W3)
  set(WERROR_FLAG /WX)
endif ()

if (MASTER_PROJECT AND CMAKE_GENERATOR MATCHES "Visual Studio")
  # If Microsoft SDK is installed create script run-msbuild.bat that
  # calls SetEnv.cmd to set up build environment and runs msbuild.
  # It is useful when building Visual Studio projects with the SDK
  # toolchain rather than Visual Studio.
  include(FindSetEnv)
  if (WINSDK_SETENV)
    set(MSBUILD_SETUP "call \"${WINSDK_SETENV}\"")
  endif ()
  # Set FrameworkPathOverride to get rid of MSB3644 warnings.
  join(netfxpath
       "C:\\Program Files\\Reference Assemblies\\Microsoft\\Framework\\"
       ".NETFramework\\v4.0")
  file(WRITE run-msbuild.bat "
    ${MSBUILD_SETUP}
    ${CMAKE_MAKE_PROGRAM} -p:FrameworkPathOverride=\"${netfxpath}\" %*")
endif ()

set(strtod_l_headers stdlib.h)
if (APPLE)
  set(strtod_l_headers ${strtod_l_headers} xlocale.h)
endif ()

include(CheckSymbolExists)
if (WIN32)
  check_symbol_exists(_strtod_l "${strtod_l_headers}" HAVE_STRTOD_L)
else ()
  check_symbol_exists(strtod_l "${strtod_l_headers}" HAVE_STRTOD_L)
endif ()

function(add_headers VAR)
  set(headers ${${VAR}})
  foreach (header ${ARGN})
    set(headers ${headers} include/fmt/${header})
  endforeach()
  set(${VAR} ${headers} PARENT_SCOPE)
endfunction()

# Define the fmt library, its includes and the needed defines.
add_headers(FMT_HEADERS chrono.h color.h compile.h core.h format.h format-inl.h
                        locale.h os.h ostream.h posix.h printf.h ranges.h)
if (FMT_OS)
  set(FMT_SOURCES src/format.cc src/os.cc)
else()
  set(FMT_SOURCES src/format.cc)
endif ()

add_library(fmt ${FMT_SOURCES} ${FMT_HEADERS} README.rst ChangeLog.rst)
add_library(fmt::fmt ALIAS fmt)

if (HAVE_STRTOD_L)
  target_compile_definitions(fmt PUBLIC FMT_LOCALE)
endif ()

if (MINGW)
  check_cxx_compiler_flag("Wa,-mbig-obj" FMT_HAS_MBIG_OBJ)
  if (${FMT_HAS_MBIG_OBJ})
    target_compile_options(fmt PUBLIC "-Wa,-mbig-obj")
  endif()
endif ()

if (FMT_WERROR)
  target_compile_options(fmt PRIVATE ${WERROR_FLAG})
endif ()
if (FMT_PEDANTIC)
  target_compile_options(fmt PRIVATE ${PEDANTIC_COMPILE_FLAGS})
endif ()

target_compile_features(fmt INTERFACE ${FMT_REQUIRED_FEATURES})

target_include_directories(fmt PUBLIC
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${FMT_INC_DIR}>)

set(FMT_DEBUG_POSTFIX d CACHE STRING "Debug library postfix.")

set_target_properties(fmt PROPERTIES
  VERSION ${FMT_VERSION} SOVERSION ${CPACK_PACKAGE_VERSION_MAJOR}
  DEBUG_POSTFIX "${FMT_DEBUG_POSTFIX}")

# Set FMT_LIB_NAME for pkg-config fmt.pc. We cannot use the OUTPUT_NAME target
# property because it's not set by default.
set(FMT_LIB_NAME fmt)
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(FMT_LIB_NAME ${FMT_LIB_NAME}${FMT_DEBUG_POSTFIX})
endif ()

if (BUILD_SHARED_LIBS)
  if (UNIX AND NOT APPLE AND NOT ${CMAKE_SYSTEM_NAME} MATCHES "SunOS" AND
      NOT EMSCRIPTEN)
    # Fix rpmlint warning:
    # unused-direct-shlib-dependency /usr/lib/libformat.so.1.1.0 /lib/libm.so.6.
    target_link_libraries(fmt -Wl,--as-needed)
  endif ()
  target_compile_definitions(fmt PRIVATE FMT_EXPORT INTERFACE FMT_SHARED)
endif ()
if (FMT_SAFE_DURATION_CAST)
  target_compile_definitions(fmt PUBLIC FMT_SAFE_DURATION_CAST)
endif()

add_library(fmt-header-only INTERFACE)
add_library(fmt::fmt-header-only ALIAS fmt-header-only)

target_compile_definitions(fmt-header-only INTERFACE FMT_HEADER_ONLY=1)
target_compile_features(fmt-header-only INTERFACE ${FMT_REQUIRED_FEATURES})

target_include_directories(fmt-header-only INTERFACE
  $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:${FMT_INC_DIR}>)

# Install targets.
if (FMT_INSTALL)
  include(CMakePackageConfigHelpers)
  set_verbose(FMT_CMAKE_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/fmt CACHE STRING
              "Installation directory for cmake files, a relative path that "
              "will be joined with ${CMAKE_INSTALL_PREFIX} or an absolute "
              "path.")
  set(version_config ${PROJECT_BINARY_DIR}/fmt-config-version.cmake)
  set(project_config ${PROJECT_BINARY_DIR}/fmt-config.cmake)
  set(pkgconfig ${PROJECT_BINARY_DIR}/fmt.pc)
  set(targets_export_name fmt-targets)

  set_verbose(FMT_LIB_DIR ${CMAKE_INSTALL_LIBDIR} CACHE STRING
              "Installation directory for libraries, a relative path that "
              "will be joined to ${CMAKE_INSTALL_PREFIX} or an absolute path.")

  set_verbose(FMT_PKGCONFIG_DIR ${CMAKE_INSTALL_LIBDIR}/pkgconfig CACHE PATH
              "Installation directory for pkgconfig (.pc) files, a relative "
              "path that will be joined with ${CMAKE_INSTALL_PREFIX} or an "
              "absolute path.")

  # Generate the version, config and target files into the build directory.
  write_basic_package_version_file(
    ${version_config}
    VERSION ${FMT_VERSION}
    COMPATIBILITY AnyNewerVersion)

  join_paths(libdir_for_pc_file "\${exec_prefix}" "${FMT_LIB_DIR}")
  join_paths(includedir_for_pc_file "\${prefix}" "${FMT_INC_DIR}")

  configure_file(
    "${PROJECT_SOURCE_DIR}/support/cmake/fmt.pc.in"
    "${pkgconfig}"
    @ONLY)
  configure_package_config_file(
    ${PROJECT_SOURCE_DIR}/support/cmake/fmt-config.cmake.in
    ${project_config}
    INSTALL_DESTINATION ${FMT_CMAKE_DIR})

  set(INSTALL_TARGETS fmt fmt-header-only)
  # Use a namespace because CMake provides better diagnostics for namespaced
  # imported targets.
  export(TARGETS ${INSTALL_TARGETS} NAMESPACE fmt::
         FILE ${PROJECT_BINARY_DIR}/${targets_export_name}.cmake)

  # Install version, config and target files.
  install(
    FILES ${project_config} ${version_config}
    DESTINATION ${FMT_CMAKE_DIR})
  install(EXPORT ${targets_export_name} DESTINATION ${FMT_CMAKE_DIR}
          NAMESPACE fmt::)

  # Install the library and headers.
  install(TARGETS ${INSTALL_TARGETS} EXPORT ${targets_export_name}
          LIBRARY DESTINATION ${FMT_LIB_DIR}
          ARCHIVE DESTINATION ${FMT_LIB_DIR}
          RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

  install(FILES $<TARGET_PDB_FILE:${INSTALL_TARGETS}>
          DESTINATION ${FMT_LIB_DIR} OPTIONAL)
  install(FILES ${FMT_HEADERS} DESTINATION "${FMT_INC_DIR}/fmt")
  install(FILES "${pkgconfig}" DESTINATION "${FMT_PKGCONFIG_DIR}")
endif ()

if (FMT_DOC)
  add_subdirectory(doc)
endif ()

if (FMT_TEST)
  enable_testing()
  add_subdirectory(test)
endif ()

# Control fuzzing independent of the unit tests.
if (FMT_FUZZ)
  add_subdirectory(test/fuzzing)

  # The FMT_FUZZ macro is used to prevent resource exhaustion in fuzzing

=== lib/fmt/test/CMakeLists.txt ===
#------------------------------------------------------------------------------
# Build the google test library

# We compile Google Test ourselves instead of using pre-compiled libraries.
# See the Google Test FAQ "Why is it not recommended to install a
# pre-compiled copy of Google Test (for example, into /usr/local)?"
# at http://code.google.com/p/googletest/wiki/FAQ for more details.
add_library(gmock STATIC
  gmock-gtest-all.cc gmock/gmock.h gtest/gtest.h gtest/gtest-spi.h)
target_compile_definitions(gmock PUBLIC GTEST_HAS_STD_WSTRING=1)
target_include_directories(gmock SYSTEM PUBLIC . gmock gtest)

find_package(Threads)
if (Threads_FOUND)
  target_link_libraries(gmock ${CMAKE_THREAD_LIBS_INIT})
else ()
  target_compile_definitions(gmock PUBLIC GTEST_HAS_PTHREAD=0)
endif ()

target_compile_definitions(gmock PUBLIC GTEST_LANG_CXX11=0)

if (MSVC)
  # Workaround a bug in implementation of variadic templates in MSVC11.
  target_compile_definitions(gmock PUBLIC _VARIADIC_MAX=10)
  
  # Disable MSVC warnings of _CRT_INSECURE_DEPRECATE functions.
  target_compile_definitions(gmock PRIVATE _CRT_SECURE_NO_WARNINGS)
  if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # Disable MSVC warnings of POSIX functions.
    target_compile_options(gmock PUBLIC -Wno-deprecated-declarations)
  endif ()
endif ()

# GTest doesn't detect <tuple> with clang.
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
  target_compile_definitions(gmock PUBLIC GTEST_USE_OWN_TR1_TUPLE=1)
endif ()

# Silence MSVC tr1 deprecation warning in gmock.
target_compile_definitions(gmock
  PUBLIC _SILENCE_TR1_NAMESPACE_DEPRECATION_WARNING=1)

#------------------------------------------------------------------------------
# Build the actual library tests

set(TEST_MAIN_SRC test-main.cc gtest-extra.cc gtest-extra.h util.cc)
add_library(test-main STATIC ${TEST_MAIN_SRC})
target_include_directories(test-main SYSTEM PUBLIC gtest gmock)
target_link_libraries(test-main gmock fmt)

include(CheckCXXCompilerFlag)

# Workaround GTest bug https://github.com/google/googletest/issues/705.
check_cxx_compiler_flag(
  -fno-delete-null-pointer-checks HAVE_FNO_DELETE_NULL_POINTER_CHECKS)
if (HAVE_FNO_DELETE_NULL_POINTER_CHECKS)
  target_compile_options(test-main PUBLIC -fno-delete-null-pointer-checks)
endif ()

# Use less strict pedantic flags for the tests because GMock doesn't compile
# cleanly with -pedantic and -std=c++98.
if (CMAKE_COMPILER_IS_GNUCXX OR (CMAKE_CXX_COMPILER_ID MATCHES "Clang"))
    #set(PEDANTIC_COMPILE_FLAGS -Wall -Wextra -Wno-long-long -Wno-variadic-macros)
endif ()

function(add_fmt_executable name)
  add_executable(${name} ${ARGN})
  if (MINGW)
    target_link_libraries(${name} -static-libgcc -static-libstdc++)
  endif ()
endfunction()

# Adds a test.
# Usage: add_fmt_test(name srcs...)
function(add_fmt_test name)
  add_fmt_executable(${name} ${name}.cc ${ARGN})
  target_link_libraries(${name} test-main)

  # Define if certain C++ features can be used.
  if (FMT_PEDANTIC)
    target_compile_options(${name} PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  endif ()
  if (FMT_WERROR)
    target_compile_options(${name} PRIVATE ${WERROR_FLAG})
  endif ()
  target_include_directories(${name} SYSTEM PUBLIC gtest gmock)
  add_test(NAME ${name} COMMAND ${name})
endfunction()

add_fmt_test(assert-test)
add_fmt_test(chrono-test)
add_fmt_test(color-test)
add_fmt_test(core-test)
add_fmt_test(gtest-extra-test)
add_fmt_test(format-test mock-allocator.h)
if (MSVC)
  target_compile_options(format-test PRIVATE /bigobj)
endif ()
if (NOT (MSVC AND BUILD_SHARED_LIBS))
  add_fmt_test(format-impl-test)
endif ()
add_fmt_test(locale-test)
add_fmt_test(ostream-test)
add_fmt_test(compile-test)
add_fmt_test(printf-test)
add_fmt_test(ranges-test)
add_fmt_test(scan-test)

if (NOT DEFINED MSVC_STATIC_RUNTIME AND MSVC)
  foreach (flag_var
			 CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
			 CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
	if (${flag_var} MATCHES "^(/|-)(MT|MTd)")
	  set(MSVC_STATIC_RUNTIME ON)
	  break()
	endif()
  endforeach()
endif()

if (NOT MSVC_STATIC_RUNTIME)
  add_fmt_executable(posix-mock-test
    posix-mock-test.cc ../src/format.cc ${TEST_MAIN_SRC})
  target_include_directories(
    posix-mock-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
  target_link_libraries(posix-mock-test gmock)
  target_include_directories(posix-mock-test SYSTEM PUBLIC gtest gmock)
  if (FMT_PEDANTIC)
    target_compile_options(posix-mock-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
  endif ()
  if (HAVE_STRTOD_L)
    target_compile_definitions(posix-mock-test PRIVATE FMT_LOCALE)
  endif ()
  add_test(NAME posix-mock-test COMMAND posix-mock-test)
  add_fmt_test(os-test)
endif ()

add_fmt_executable(header-only-test
  header-only-test.cc header-only-test2.cc test-main.cc)
target_link_libraries(header-only-test gmock)
target_include_directories(header-only-test SYSTEM PUBLIC gtest gmock)
if (TARGET fmt-header-only)
  target_link_libraries(header-only-test fmt-header-only)
else ()
  target_include_directories(
    header-only-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
  target_compile_definitions(header-only-test PRIVATE FMT_HEADER_ONLY=1)
endif ()

message(STATUS "FMT_PEDANTIC: ${FMT_PEDANTIC}")

if (FMT_PEDANTIC AND CXX_STANDARD LESS 20)
  # MSVC fails to compile GMock when C++17 is enabled.
  if (FMT_HAS_VARIANT AND NOT MSVC)
    add_fmt_test(std-format-test)
    set_property(TARGET std-format-test PROPERTY CXX_STANDARD 17)
  endif ()

  # Test that the library can be compiled with exceptions disabled.
  # -fno-exception is broken in icc: https://github.com/fmtlib/fmt/issues/822.
  if (NOT CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
    check_cxx_compiler_flag(-fno-exceptions HAVE_FNO_EXCEPTIONS_FLAG)
  endif ()
  if (HAVE_FNO_EXCEPTIONS_FLAG)
    add_library(noexception-test ../src/format.cc)
    target_include_directories(
      noexception-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
    target_compile_options(noexception-test PRIVATE -fno-exceptions)
    if (FMT_PEDANTIC)
      target_compile_options(noexception-test PRIVATE ${PEDANTIC_COMPILE_FLAGS})
    endif ()
  endif ()

  # Test that the library compiles without locale.
  add_library(nolocale-test ../src/format.cc)
  target_include_directories(
    nolocale-test PRIVATE ${PROJECT_SOURCE_DIR}/include)
  target_compile_definitions(
    nolocale-test PRIVATE FMT_STATIC_THOUSANDS_SEPARATOR=1)

  add_test(compile-error-test ${CMAKE_CTEST_COMMAND}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/compile-error-test"
    "${CMAKE_CURRENT_BINARY_DIR}/compile-error-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DCXX_STANDARD_FLAG=${CXX_STANDARD_FLAG}"
    "-DPEDANTIC_COMPILE_FLAGS=${PEDANTIC_COMPILE_FLAGS}"
    "-DSUPPORTS_USER_DEFINED_LITERALS=${SUPPORTS_USER_DEFINED_LITERALS}")
endif ()

# These tests are disabled on Windows because they take too long.
if (FMT_PEDANTIC AND NOT WIN32)
  # Test if the targets are found from the build directory.
  add_test(find-package-test ${CMAKE_CTEST_COMMAND}
    -C ${CMAKE_BUILD_TYPE}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/find-package-test"
    "${CMAKE_CURRENT_BINARY_DIR}/find-package-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DFMT_DIR=${PROJECT_BINARY_DIR}"
    "-DPEDANTIC_COMPILE_FLAGS=${PEDANTIC_COMPILE_FLAGS}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")

  # Test if the targets are found when add_subdirectory is used.
  add_test(add-subdirectory-test ${CMAKE_CTEST_COMMAND}
    -C ${CMAKE_BUILD_TYPE}
    --build-and-test
    "${CMAKE_CURRENT_SOURCE_DIR}/add-subdirectory-test"
    "${CMAKE_CURRENT_BINARY_DIR}/add-subdirectory-test"
    --build-generator ${CMAKE_GENERATOR}
    --build-makeprogram ${CMAKE_MAKE_PROGRAM}
    --build-options
    "-DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER}"
    "-DCMAKE_CXX_STANDARD=${CMAKE_CXX_STANDARD}"
    "-DPEDANTIC_COMPILE_FLAGS=${PEDANTIC_COMPILE_FLAGS}"
    "-DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
endif ()

# Activate optional CUDA tests if CUDA is found. For version selection see
# https://docs.nvidia.com/cuda/cuda-c-programming-guide/index.html#cpp14-language-features
if (FMT_CUDA_TEST)
  if (${CMAKE_VERSION} VERSION_LESS 3.15)
    find_package(CUDA 9.0)
  else ()
    include(CheckLanguage)
    check_language(CUDA)
    if (CMAKE_CUDA_COMPILER)
      enable_language(CUDA OPTIONAL)
      set(CUDA_FOUND TRUE)
    endif ()
  endif ()

  if (CUDA_FOUND)
    add_subdirectory(cuda-test)
    add_test(NAME cuda-test COMMAND fmt-in-cuda-test)
  endif ()
endif ()

=== packaging/debian/changelog ===
mkvtoolnix (58.0.0-0~bunkus01) hirsute; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 13 Jun 2021 12:45:01 +0200

mkvtoolnix (57.0.0-0~bunkus01) hirsute; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 22 May 2021 12:32:27 +0200

mkvtoolnix (56.1.0-0~bunkus01) groovy; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Fri, 09 Apr 2021 18:11:48 +0200

mkvtoolnix (56.0.0-0~bunkus01) groovy; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Mon, 05 Apr 2021 12:07:25 +0200

mkvtoolnix (55.0.0-0~bunkus01) groovy; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 06 Mar 2021 12:46:46 +0100

mkvtoolnix (54.0.0-0~bunkus01) groovy; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Fri, 26 Feb 2021 19:12:20 +0100

mkvtoolnix (53.0.0-0~bunkus01) groovy; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 30 Jan 2021 16:06:44 +0100

mkvtoolnix (52.0.0-0~bunkus01) groovy; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Mon, 04 Jan 2021 22:29:12 +0100

mkvtoolnix (51.0.0-0~bunkus01) focal; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 04 Oct 2020 13:10:40 +0200

mkvtoolnix (50.0.0-0~bunkus01) focal; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 06 Sep 2020 11:40:15 +0200

mkvtoolnix (49.0.0-0~bunkus01) focal; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 02 Aug 2020 13:13:55 +0200

mkvtoolnix (48.0.0-0~bunkus01) focal; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 27 Jun 2020 18:46:02 +0200

mkvtoolnix (47.0.0-0~bunkus01) focal; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 30 May 2020 14:10:35 +0200

mkvtoolnix (46.0.0-0~bunkus01) focal; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Fri, 01 May 2020 10:35:13 +0200

mkvtoolnix (45.0.0-0~bunkus01) eoan; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 04 Apr 2020 14:29:35 +0200

mkvtoolnix (44.0.0-0~bunkus01) eoan; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 08 Mar 2020 19:01:17 +0100

mkvtoolnix (43.0.0-0~bunkus01) eoan; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 26 Jan 2020 14:45:13 +0100

mkvtoolnix (42.0.0-0~bunkus01) eoan; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Thu, 02 Jan 2020 12:52:42 +0100

mkvtoolnix (41.0.0-0~bunkus01) eoan; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Fri, 06 Dec 2019 18:27:52 +0100

mkvtoolnix (40.0.0-0~bunkus01) eoan; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 09 Nov 2019 11:19:04 +0100

mkvtoolnix (39.0.0-0~bunkus01) eoan; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Mon, 04 Nov 2019 21:52:50 +0100

mkvtoolnix (38.0.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 06 Oct 2019 14:09:47 +0200

mkvtoolnix (37.0.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 24 Aug 2019 10:01:18 +0200

mkvtoolnix (36.0.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 10 Aug 2019 16:17:42 +0200

mkvtoolnix (35.0.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 22 Jun 2019 11:05:58 +0200

mkvtoolnix (34.0.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 18 May 2019 13:18:51 +0200

mkvtoolnix (33.1.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 14 Apr 2019 23:55:34 +0200

mkvtoolnix (33.0.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Fri, 12 Apr 2019 15:25:41 +0200

mkvtoolnix (32.0.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Tue, 12 Mar 2019 21:28:50 +0100

mkvtoolnix (31.0.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 09 Feb 2019 11:26:12 +0100

mkvtoolnix (30.1.0-0~bunkus01) xenial; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 05 Jan 2019 16:08:45 +0100

mkvtoolnix (30.0.0-0~bunkus01) cosmic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Fri, 04 Jan 2019 13:18:33 +0100

mkvtoolnix (29.0.0-0~bunkus01) cosmic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 01 Dec 2018 12:13:44 +0100

mkvtoolnix (28.2.0-0~bunkus01) cosmic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Thu, 25 Oct 2018 22:18:27 +0200

mkvtoolnix (28.1.0-0~bunkus01) cosmic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Tue, 23 Oct 2018 20:46:02 +0200

mkvtoolnix (28.0.0-0~bunkus01) cosmic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sat, 20 Oct 2018 16:29:09 +0200

mkvtoolnix (27.0.0-0~bunkus01) bionic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Wed, 26 Sep 2018 18:43:03 +0200

mkvtoolnix (26.0.0-0~bunkus01) bionic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 26 Aug 2018 12:53:12 +0200

mkvtoolnix (25.0.0-0~bunkus01) bionic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Thu, 12 Jul 2018 19:55:51 +0200

mkvtoolnix (24.0.0-0~bunkus01) bionic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 10 Jun 2018 11:32:58 +0200

mkvtoolnix (23.0.0-0~bunkus01) bionic; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Wed, 02 May 2018 14:52:50 +0200

mkvtoolnix (22.0.0-0~bunkus01) artful; urgency=low

  * New version.

 -- Moritz Bunkus <moritz@bunkus.org>  Sun, 01 Apr 2018 17:24:58 +0200

mkvtoolnix (21.0.0-0~bunkus01) artful; urgency=low



=== packaging/debian/control ===
Source: mkvtoolnix
Section: video
Priority: optional
Maintainer: Moritz Bunkus <moritz@bunkus.org>
Homepage: https://mkvtoolnix.download/
Standards-Version: 3.9.5
Build-Depends:
 debhelper (>= 9),
 rake (>= 10),
 libbz2-dev, liblzo2-dev, zlib1g-dev, libmagic-dev,
 libflac-dev, libogg-dev, libvorbis-dev,
 libboost-dev (>= 1.66), qtbase5-dev, qtbase5-dev-tools,
 qtmultimedia5-dev, qt5-default | base-files (>= 11ubuntu18),
 libcmark-dev, libgtest-dev, libfmt-dev (>= 4), libdvdread-dev,
 libpcre2-dev, libpcre2-8-0, nlohmann-json3-dev,
 pkg-config, po4a, docbook-xsl, xsltproc

Package: mkvtoolnix
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: mkvtoolnix-gui
Description: Set of command-line tools to work with Matroska files
 Matroska is a new multimedia container format, based on EBML (Extensible
 Binary Meta Language), which is a kind of binary XML.
 These tools allow one to manipulate Matroska files.
  * mkvmerge is a tool to create Matroska files from other formats
  * mkvinfo allows one to get information about the tracks in a Matroska file
  * mkvextract can extract tracks from Matroska files to other formats
  * mkvpropedit can edit header and chapter information without remuxing
 .
 This package only provides command-line tools. For graphical tools, you
 should install the mkvtoolnix-gui package.

Package: mkvtoolnix-gui
Architecture: any
Depends: mkvtoolnix (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: mediainfo-gui
Replaces: mkvtoolnix (<= 4.6.0-1)
Description: Set of tools to work with Matroska files - GUI frontend
 Matroska is a new multimedia container format, based on EBML (Extensible
 Binary Meta Language), which is a kind of binary XML.
 .
 The mkvtoolnix-gui tool is a graphical user interface for the mkvmerge
 program, which allows one to create Matroska files from other formats.

Package: mkvtoolnix-dbg
Section: debug
Priority: extra
Architecture: any
Depends: mkvtoolnix (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for mkvtoolnix
 Matroska is a new multimedia container format, based on EBML (Extensible
 Binary Meta Language), which is a kind of binary XML.
 These tools allow one to manipulate Matroska files.
  * mkvmerge is a tool to create Matroska files from other formats
  * mkvinfo allows one to get information about the tracks in a Matroska file
  * mkvextract can extract tracks from Matroska files to other formats
  * mkvpropedit can edit header and chapter information without remuxing
 .
 This package contains the debugging symbols for the command-line tools
 of mkvtoolnix.

Package: mkvtoolnix-gui-dbg
Section: debug
Priority: extra
Architecture: any
Depends: mkvtoolnix-gui (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for mkvtoolnix-gui
 Matroska is a new multimedia container format, based on EBML (Extensible
 Binary Meta Language), which is a kind of binary XML.
 These tools allow one to manipulate Matroska files.
  * mkvmerge is a tool to create Matroska files from other formats
  * mkvinfo allows one to get information about the tracks in a Matroska file
  * mkvextract can extract tracks from Matroska files to other formats
  * mkvpropedit can edit header and chapter information without remuxing
 .
 This package contains the debugging symbols for the GUI of
 mkvtoolnix-gui.
